# Workflow Challenges & Tips

Workflow systems are very powerful tools but also have their challenges & limitations as described in the [Dapr docs](https://docs.dapr.io/developing-applications/building-blocks/workflow/workflow-features-concepts/#limitations).

This section provides some tips with code snippets to understand the limitations and get the most out of the Dapr Workflow API. Read through the following examples to learn best practices to develop Dapr workflows.

- [Deterministic workflows](DeterministicWorkflow.cs)
- [Idempotent activities](IdempotentActivity.cs)
- [Versioning workflows](VersioningWorkflow.cs)
- [Workflow & activity payload size](PayloadSizeWorkflow.cs)
